Bug 56494 - PowerXpress doesn't work with Radeon HD 6550M / Intel Core i5-480M IGP [MUXLESS platform]
PowerXpress doesn't work with Radeon HD 6550M / Intel Core i5-480M IGP [MUXLE...
Status: RESOLVED NOTOURBUG
Product: xorg
Classification: Unclassified
Component: Driver/intel
7.7 (2012.06)
Other All
: medium normal
Assigned To: Chris Wilson
Xorg Project Team
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2012-10-28 14:04 UTC by sfievet
Modified: 2012-12-09 15:55 UTC (History)
1 user (show)

See Also:


Attachments
Xorg log when unsupported muxless platform is reported (7.57 KB, text/plain)
2012-10-28 14:04 UTC, sfievet
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description sfievet 2012-10-28 14:04:57 UTC
Created attachment 69191 [details]
Xorg log when unsupported muxless platform is reported

Bug already reported to AMD, but since it seems to involve Intel driver, I thought it might be a good idea to report here as well.

Actually two similar bugs have been reported to AMD :
http://ati.cchtml.com/show_bug.cgi?id=634 (reported by me)
http://ati.cchtml.com/show_bug.cgi?id=580

I am the owner of an ACER Aspire TimelineX 3820 TG featuring a core i5-480M +
Radeon HD6550M.
Configuration (32 bits ONLY installation) :
- kernel 3.4.14
- glibc 2.14.1
- gcc 4.6.1
- Xorg 7.7 with xorg-server 1.12.1 / xf86-video-intel 2.20.10
- Slim 1.3.2
- fglrx 12.10 or 12.11 beta

X works fine with :
- the dGPU only ("discrete" selected in the bios)
- the IGP only ("switchable" selected in the bios and dGPU NOT declared in the
ServerLayout section).

X crashes at startup when :
- "switchable graphics" is selected in the bios
- only the dGPU is declared in the ServerLayout :
excerpt of Xorg.0.log
... snip ...
[    20.778] (==) ServerLayout "laptop"
[    20.778] (**) |-->Screen "high performance" (1)
[    20.778] (**) |   |-->Monitor "Acer 3820TG"
[    20.778] (**) |   |-->Device "Radeon HD 6550M"
... snip ...
[    20.780] (--) PCI:*(0:0:2:0) 8086:0046:1025:051b rev 24, Mem @
0xf0000000/4194304, 0xd0000000/268435456, I/O @ 0x00001800/8
[    20.780] (--) PCI: (0:2:0:0) 1002:68c1:1025:051b rev 0, Mem @
0xb0000000/268435456, 0xafee0000/131072, I/O @ 0x00002000/256, BIOS @
0x????????/131072
... snip ...
[    20.865] (--) Chipset Supported AMD Graphics Processor (0x68C1) found
[    20.866] (WW) fglrx: No matching Device section for instance (BusID
PCI:0@2:0:1) found
[    20.866] (II) fglrx: intel VGA device detected, load intel driver.
[    20.866] (II) LoadModule: "intel"
[    20.866] (II) Loading /opt/X11/lib/xorg/modules/drivers/intel_drv.so
[    20.866] (II) Module intel: vendor="X.Org Foundation"
[    20.866]    compiled for 1.12.2, module version = 2.20.10
[    20.866]    Module class: X.Org Video Driver
[    20.866]    ABI class: X.Org Video Driver, version 12.0
[    20.866] (WW) PowerXpress feature is not supported on A+I Mux platform.
Please uninstall fglrx driver.
[    20.866] (EE) this is a Muxless PX A+I platform, we doesn't supported it
[    20.866] (EE) No devices detected.
[    20.866] 
Fatal server error:
[    20.866] no screens found

I am a bit puzzled by :
"this is a Muxless PX A+I platform, we doesn't supported it"

X crashes at startup when :
- "switchable graphics" is selected in the bios
- both dGPU (Radeon HD 6550M) and iGPU (Core i5 IGP) are declared in the
ServerLayout section :

excerpt of Xorg.0.log
... snip ...
[   205.098] (==) ServerLayout "laptop"
[   205.098] (**) |-->Screen "low power" (0)
[   205.098] (**) |   |-->Monitor "Acer 3820TG"
[   205.098] (**) |   |-->Device "Intel HD Graphics"
[   205.098] (**) |-->Screen "high performance" (1)
[   205.099] (**) |   |-->Monitor "Acer 3820TG"
[   205.099] (**) |   |-->Device "Radeon HD 6550M"
... snip ...
[   142.387] (--) PCI:*(0:0:2:0) 8086:0046:1025:051b rev 24, Mem @
0xf0000000/4194304, 0xd0000000/268435456, I/O @ 0x00001800/8
[   142.387] (--) PCI: (0:2:0:0) 1002:68c1:1025:051b rev 0, Mem @
0xb0000000/268435456, 0xafee0000/131072, I/O @ 0x00002000/256, BIOS @
0x????????/131072
... snip ...
[   142.490] (II) fglrx(1): === [xdl_xs112_atiddxPreInit] === begin
[   142.491] 
[   142.491] Backtrace:
[   142.491] 0: /opt/X11/bin/X (xorg_backtrace+0x49) [0x81c3f59]
[   142.491] 1: /opt/X11/bin/X (0x8048000+0x17f83a) [0x81c783a]
[   142.491] 2: (vdso) (__kernel_rt_sigreturn+0x0) [0xb771540c]
[   142.491] 3: /opt/X11/lib/xorg/modules/drivers/fglrx_drv.so
(xdl_xs112_atiddxPxPreInit+0xa9) [0xb6893409]
[   142.491] 4: /opt/X11/lib/xorg/modules/drivers/fglrx_drv.so
(xdl_xs112_atiddxPreInit+0x2282) [0xb686cd52]
[   142.491] 5: /opt/X11/bin/X (InitOutput+0x85b) [0x80bcd8b]
[   142.491] 
[   142.491] Segmentation fault at address 0x62
[   142.491] 
Fatal server error:
[   142.491] Caught signal 11 (Segmentation fault). Server aborting

Thank you for your support,
Seb.
Comment 1 Chris Wilson 2012-10-30 11:54:12 UTC
There is nothing I can do about this since fglrx plays tricks with the intel hardware without knowledge of the driver.
Comment 2 sfievet 2012-10-30 21:06:12 UTC
I thought so... But wanted to report anyway.
I added a comment to my bug report in AMD's bugzilla referencing this one.
'hope this will help.

Thanks a lot for the quality of your driver.
Comment 3 Nick Andrik 2012-11-01 02:44:58 UTC
Chris, can you take a look on the workaround proposed on my comment #44 in this bug report?
https://bugs.launchpad.net/ubuntu/+source/fglrx-installer-updates/+bug/1068404

If you revert (or "debug") the mentioned patch then the driver works for intel/ati systems.
Comment 4 Nick Andrik 2012-12-05 14:30:42 UTC
Could someone check that this commit can work with muxless hybrid systems?

http://cgit.freedesktop.org/xorg/driver/xf86-video-intel/commit/?id=05dcc5f1699ba90fc14c50882e8d4be89bc4a4f9

These are systems, such as laptops, where the rendering happens in one GPU (integrated Intel or discrete ATI/Nvidia), but the actual display is always from the Intel card.

I'm telling that because if I revert this commit, my hybrid fglrx/intel system works again with no segfaults on the X server.

Thanks!
Comment 5 Chris Wilson 2012-12-06 09:20:36 UTC
The proprietary driver is playing games with -intel using private symbols.
Comment 6 Nick Andrik 2012-12-06 13:25:42 UTC
OK, I understand that and the reason that you don't want to change it upstream.

But, would you be kind enough to comment for the specific commit and if it would be ok to revert it in the distribution level till fglrx is fixed?

Is it safe to do so, or you expect other side-effects?

Personally I have checked reverting it for versions 2.20.3, 2.20.9, 2.20.12 and it seems to work fine, but I am really interested in your opinion.

Thank you for your time.
Comment 7 Chris Wilson 2012-12-06 13:39:22 UTC
For the time being, all you will get is some extra noise in Xorg.log. It is not a long term solution, as I want to continue removing obsolete (old UMS only interfaces) code/data from those functions.
Comment 8 Nick Andrik 2012-12-06 13:45:58 UTC
If the functionality is not broken, then I think it is safe to revert that change in order to have the hybrid systems working for now.

I agree that it is not the best long term solution, but till fglrx is fixed, I don't see any other route, right?
Comment 9 sfievet 2012-12-06 22:00:21 UTC
(In reply to comment #4)
> Could someone check that this commit can work with muxless hybrid systems?
> 
> http://cgit.freedesktop.org/xorg/driver/xf86-video-intel/commit/
> ?id=05dcc5f1699ba90fc14c50882e8d4be89bc4a4f9
> 
> These are systems, such as laptops, where the rendering happens in one GPU
> (integrated Intel or discrete ATI/Nvidia), but the actual display is always
> from the Intel card.
> 
> I'm telling that because if I revert this commit, my hybrid fglrx/intel
> system works again with no segfaults on the X server.
> 
> Thanks!

I just tried and reverted it on 2.20.15 combined with fglrx 12.10 with no luck :-(
What puzzles me is :

[    23.084] (EE) this is a Muxless PX A+I platform, we doesn't supported it
I thought powerxpress v4+ was MEANT for muxless platforms!

... But thank you for your help anyway. 
I guess all I can do is wait for AMD to work on it.
Comment 10 Nick Andrik 2012-12-07 01:41:45 UTC
Try it with 2.20.12 because maybe .15 has introduced more changes.
Moreover, if you use a specific distribution, report the bug there, e.g. for ubuntu there are already prepared packages that you could use
Comment 11 sfievet 2012-12-07 08:48:43 UTC
(In reply to comment #10)
> Try it with 2.20.12 because maybe .15 has introduced more changes.
> Moreover, if you use a specific distribution, report the bug there, e.g. for
> ubuntu there are already prepared packages that you could use

I run "Linux from Scratch" distro, so I built everything from sources.
I have been doing it for 10 years now, so i feel comfortable with that.
[even though I am far from being a SW dev]
I will try again with 2.20.12 and report.
Comment 12 sfievet 2012-12-09 13:55:46 UTC
(In reply to comment #11)
tried with 2.20.12. don't work either :-(

weird thing is that :
- if I don't force the loading of both drivers, fglrx stops 
claiming that "this is a Muxless PX A+I platform, we doesn't supported it".
-if I do (by adding both cards to the layout section), then X crashes. :-(

My take is that it's probably more complicated than a driver to driver communication issue, and that AMD don't support all its platforms.
It's really frustrating. :-(

At least I can use the intel driver decently!
Thanks for your support anyway...
Comment 13 Nick Andrik 2012-12-09 14:22:27 UTC
@sfievet 

I proposed to apply the patch, not take the official release as is :)
If you want to take a working official release, then you should go for 2.20.2 .
I am not sure how compatible this is with your graphics stack (Xorg, etc).

My proposal is:
1. Take the official 2.20.12 version
2. Apply the patch from here:
https://bugs.launchpad.net/ubuntu/+source/fglrx-installer-updates/+bug/1068404/+attachment/3418227/+files/fix-ati-hybrid.patch
3. Recompile, load and reboot

This should be working. If you are kind enough to try also for the most recent upstream (2.20.15 ? ) I would be really interested in your results

Thanks
Comment 14 sfievet 2012-12-09 15:23:21 UTC
(In reply to comment #13)
> @sfievet 
> 
> I proposed to apply the patch, not take the official release as is :)
> If you want to take a working official release, then you should go for
> 2.20.2 .
> I am not sure how compatible this is with your graphics stack (Xorg, etc).
> 
> My proposal is:
> 1. Take the official 2.20.12 version
> 2. Apply the patch from here:
> https://bugs.launchpad.net/ubuntu/+source/fglrx-installer-updates/+bug/
> 1068404/+attachment/3418227/+files/fix-ati-hybrid.patch
> 3. Recompile, load and reboot
> 
> This should be working. If you are kind enough to try also for the most
> recent upstream (2.20.15 ? ) I would be really interested in your results
> 
> Thanks

I know :-)
When I said I tried 2.20.12 I meant I reverted 05dcc5f1699ba90fc14c50882e8d4be89bc4a4f9 on it and tried.
I also reverted this commit on 2.20.15 and tried. No luck.
then I tried 2.20.15 and 2.20.10 with your patch and still no luck. :-(
I always get :
[snip]
[    21.047] (II) fglrx: intel VGA device detected, load intel driver.
[    21.047] (II) LoadModule: "intel"
[    21.047] (II) Loading /opt/X11/lib/xorg/modules/drivers/intel_drv.so
[    21.047] (II) Module intel: vendor="X.Org Foundation"
[    21.047]    compiled for 1.12.2, module version = 2.20.15
[    21.047]    Module class: X.Org Video Driver
[    21.047]    ABI class: X.Org Video Driver, version 12.0
[    21.047] (WW) PowerXpress feature is not supported on A+I Mux platform. Please uninstall fglrx driver.
[    21.047] (EE) this is a Muxless PX A+I platform, we doesn't supported it
[    21.047] (EE) No devices detected.
[    21.047] 
Fatal server error:
[    21.047] no screens found
[    21.047] 
[/snip]
Comment 15 Nick Andrik 2012-12-09 15:28:45 UTC
Oh, that is different from what I take.

What version of fglrx do you have? Can you use the latest one?
I think you also need Xorg 1.13 in order for the hybrid to work

My patch fixes a segmentation fault, not the "not supported message"



Nikos
Comment 16 sfievet 2012-12-09 15:37:28 UTC
(In reply to comment #15)

I am using 12.11 beta 11 (latest)... Also tried with 12.10.
Not sure about Xorg 1.13. I think Catalyst still doesn't support it. :-(

Thank you anyway!
Seb.
Comment 17 Nick Andrik 2012-12-09 15:55:29 UTC
On my Ubuntu machine I have
fglrx: 12.11-beta11
xorg-intel: 2.20.12 (patched)
xserver: 1.13.0

From your logs I see that you have X server of "1.12.2".
Hybrid operation was included only in 1.13, so try it

Nikos